services:
  broker:
    container_name: paperless-broker
    image: docker.io/library/redis:7
    restart: unless-stopped
    volumes:
      - ./redisdata:/data

  db:
    image: docker.io/library/postgres:15
    restart: unless-stopped
    volumes:
      - ./pgdata:/var/lib/postgresql/data
    environment:
      POSTGRES_DB: paperless
      POSTGRES_USER: paperless
      POSTGRES_PASSWORD: paperless
    container_name: paperless-db

  webserver:
    image: ghcr.io/paperless-ngx/paperless-ngx:latest
    container_name: paperless-ngx
    restart: unless-stopped
    depends_on:
      - db
      - broker
      - gotenberg
      - tika
    ports:
      - "8000:8000"
    healthcheck:
      test: ["CMD", "curl", "-fs", "-S", "--max-time", "2", "http://localhost:8000"]
      interval: 30s
      timeout: 10s
      retries: 5
    volumes:
      - ./data:/usr/src/paperless/data
      - ./media:/usr/src/paperless/media
      - ./export:/usr/src/paperless/export
      - ./consume:/usr/src/paperless/consume
    env_file: .docker-compose.env
    environment:
      PAPERLESS_REDIS: redis://broker:6379
      PAPERLESS_DBHOST: db
      PAPERLESS_TIKA_ENABLED: 1
      PAPERLESS_TIKA_GOTENBERG_ENDPOINT: http://gotenberg:3000
      PAPERLESS_TIKA_ENDPOINT: http://tika:9998
      PAPERLESS_OAUTH_CALLBACK_BASE_URL: https://paperless.ccalifice.com
      PAPERLESS_URL: https://paperless.ccalifice.com
      PAPERLESS_OUTLOOK_OAUTH_CLIENT_ID: '0285b467-7522-4845-ac05-3e89aa2e1024'
      PAPERLESS_OUTLOOK_OAUTH_CLIENT_SECRET: 'l1F8Q~TqHOiy~6CL2kXEIjIQz-SoaJ.AuQ_0saN9'
      USERMAP_UID: 1000
      USERMAP_GID: 1002
    networks:
      - default
      - caddy-net

  gotenberg:
    image: docker.io/gotenberg/gotenberg:8.3.0
    restart: unless-stopped
    # The gotenberg chromium route is used to convert .eml files. We do not
    # want to allow external content like tracking pixels or even javascript.
    command:
      - "gotenberg"
      - "--chromium-disable-javascript=true"
      - "--chromium-allow-list=file:///tmp/.*"
    container_name: gotenberg

  tika:
    image: ghcr.io/paperless-ngx/tika:latest
    restart: unless-stopped
    container_name: tika

networks:
  caddy-net:
    external: true
    name: caddy-net
  paperless-net:
